/*	
 *	clipgym.h
 *
 *	P/ECE GYM Driver
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Thu Dec 9 18:16:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_GYM_H__
#define __CLIP_GYM_H__

/****************************************************************************
 *	GYMt@Cdl
 ****************************************************************************/

/*
 *	GYMt@Cwb_
 */
typedef struct _GYMHEADER {
	char identifier[4];			/* +  0,  4: Identifier: the characters 'G' 'Y' 'M' 'X' */
	char song_title[32];			/* +  4, 32: Song title */
	char game_title[32];			/* + 36, 32: Game title */
	char game_publisher[32];		/* + 68, 32: Game publisher */
	char name_of_emulator[32];		/* +100, 32: Name of emulator used to create the gym file */
	char name_of_person[32];		/* +132, 32: Name of person who created the gym file */
	char miscelaneous_comments[256];	/* +164,256: Miscelaneous comments */
	int  loop_integer;			/* +420,  4: Loop integer (unsigned little endian). */
						/*           Zero if the gym should not loop. */
						/*           Otherwise it specifies the point (1 being the very beginning) at which looping begins in 1/60 seconds. */
	int  uncompressed_size;			/* +424,  4: Specifies the uncompressed size (unsigned little endian) of the raw gym data if the gym data has been compressed with zlib (deflate algorythm). */
						/*           Zero if not compressed. */
} GYMHEADER;					/* =428 */
// ̂Ƃraw gym data܂B

/****************************************************************************
 *	GYMhCo
 ****************************************************************************/

#define GYMBUFLEN	320 /* =16000/50 c 1[tick](=1/50[sec])̃Tv */
#define GYMBUFLEN_60	267 /* =16000/60 c 1/60[sec]̃Tv (GYMP) */
#define GYMBUFLEN_DAC	GYMBUFLEN_60 /* 1/60[sec]DACo̓Tv */

/*
 *	GYMhCo
 */
typedef struct _GYMDRIVER {
	YM2612* ym2612;					/* YM2612  chip (RAMɔzu) */
	SN76489* sn76489;				/* SN76489 chip (   SRAMɔzu) */

	const unsigned char* data_pos;			/* raw gym dataʒu */
	const unsigned char* data_end;			/* raw gym dataI[ʒu */

	int tmpcnt;					/* tmpbuf̎cTv */
	short tmpbuf[3][GYMBUFLEN + GYMBUFLEN_60];	/* 1/601/50ϊp̈ꎞobt@ ([0]=YM2612, [1]=SN76489, [2]=DAC) */
} GYMDRIVER;

/*
 *	GYMhCo֐
 */
int gym_init(GYMDRIVER* driver, const void* romp, int size);
int gym_mix(GYMDRIVER* driver, short wbuff[/*GYMBUFLEN*/]);
int gym_stream_callback(short* wbuff, int param);
void gym_dacmix(short dst[/*GYMBUFLEN_60*/], const short src[/*daccnt*/], int daccnt);
void gym_copy(const short src1[/*GYMBUFLEN*/], const short src2[/*GYMBUFLEN*/], const short src3[/*GYMBUFLEN*/], short dst[/*GYMBUFLEN*/]);

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

/* GYMt@C̍ĐJn܂B
 * [in]
 *	romp		GYMf[^̐擪AhXB
 *	size		GYMf[^̃oCgB
 * [out]
 *	߂l		ĐJnɐA 0Ԃ܂B
 *			ĐJnłȂ΁A-1Ԃ܂B
 * [note]
 *	* ̊֐͓stream_play()ĂяoĂ܂B
 *	* stream_play()ĂԂƁATEh荞݃xN^tbN܂B
 *	  vOIOɕKgym_stop()ĂŁAxN^𕜌ĂB
 */
int gym_play(const void* romp, int size);

/* GYMt@C̍Đ~܂B
 * [note]
 *	* ĐłȂ΁Å֐͉܂B
 */
void gym_stop();

#endif /*__CLIP_GYM_H__*/
